Java学习笔记--异常处理(传智播客的总结)-阿里云开发者社区

开发者社区> 开发与运维> 正文

Java学习笔记--异常处理(传智播客的总结)

简介: 背景: 我们的java程序也是会存在某些不正常 的情况的,这些不正常的 情况我们就统称异常。(还有一种是IO流的异常 要包装成运行时异常) 异常体系: ———-| Throwable 所以异常或者错误类的超类 ————–|Error 错误 错误一般是用于jvm或者是硬件引发的问题,所以我们一般不会通过代码去处理错误的。

背景:

我们的java程序也是会存在某些不正常 的情况的,这些不正常的 情况我们就统称异常。(还有一种是IO流的异常 要包装成运行时异常)

异常体系:
———-| Throwable 所以异常或者错误类的超类
————–|Error 错误 错误一般是用于jvm或者是硬件引发的问题,所以我们一般不会通过代码去处理错误的。
————–|Exception 异常 是需要通过代码去处理的。

如何区分错误与异常呢:
如果程序出现了不正常的信息,如果不正常的信息的类名是以Error结尾的,那么肯定是一个错误。
如果是以Exception结尾的,那么肯定就是一个异常。


Throwable常用的方法:
toString() 返回当前异常对象的完整类名+病态信息。 包名+类名 = 完整类名
getMessage() 返回的是创建Throwable传入的字符串信息。
printStackTrace() 打印异常的栈信息

比如:虚拟机能分配的内存是50多mb如果超过了就是Error类型的

疑问: 下面的信息是通过printStackTrace方法打印出来,那么异常对象从何而来呢?
Exception in thread “main” java.lang.ArithmeticException: / by zero
at Demo10.div(Demo10.java:10)
at Demo10.main(Demo10.java:5)

jvm运行到a/b这个语句的时候,发现b为0,除数为0在我们现实生活中是属于
不正常的情况,jvm一旦发现了这种不正常的情况时候,那么jvm就会马上创建
一个对应的异常对象,并且会调用这个异常对象 的printStackTrace的方法来处理。

异常的处理:

 方式一:捕获处理

  捕获处理的格式:

        try{
            可能发生异常的代码;

        }catch(捕获的异常类型 变量名){
            处理异常的代码....
        }

捕获处理要注意的细节:

  1. 如果try块中代码出了异常经过了处理之后,那么try-catch块外面的代码可以正常执行。
  2. 如果try块中出了异常的代码,那么在try块中出现异常代码后面的代码是不会执行了。
  3. 一个try块后面是可以跟有多个catch块的,也就是一个try块可以捕获多种异常的类型。
  4. 一个try块可以捕获多种异常的类型,但是捕获的异常类型必须从小到大进行捕获,否则编译报错。

疑问一 : 异常的处理感觉没有多大作用,因为都是输出一个话而已?
异常处理非常有用,只不过是由于我们目前所接触的知识点太过于局限而已。

疑问二: 以后捕获处理 的时候是否就是捕获Exception即可?
错的,因为我们在现实开发中遇到不同的异常类型的时候,我往往会有不同 的处理方式。
所以要分开不同的异常类型处理。

注意 如果抛出了一个异常 那么接下来的代码就不会执行

*/
举例:
try catch方法
class A{
    public static void main(String[] args){
        div(1,0);
    }
    public static void div(int a,int b){
        int c=0;
        try{
            c=a/b;
        }catch(ArithmeticException e){
            System.out.println("1");
        }catch(NullPointerException e){
            System.out.println("2");
        }catch(Exception e){
            System.out.println("3");
        }

    }
}

/*
异常的处理方式----抛出处理

抛出处理(throw throws)

抛出处理要注意的细节:
1. 如果一个方法的内部抛出了一个异常 对象,那么必须要在方法上声明抛出。
2. 如果调用了一个声明抛出异常 的方法,那么调用者必须要处理异常。
3. 如果一个方法内部抛出了一个异常对象,那么throw语句后面的代码都不会再执行了(一个方法遇到了throw关键字,该方法也会马上停止执行的)。
4. 在一种情况下,只能抛出一种类型异常对象。

throw 与throws两个关键字:
1. throw关键字是用于方法内部的,throws是用于方法声声明上的。
2. throw关键字是用于方法内部抛出一个异常对象的,throws关键字是用于在方法声明上声明抛出异常类型的。
3. throw关键字后面只能有一个异常对象,throws后面一次可以声明抛出多种类型的 异常。

疑问:何时使用抛出处理?何时捕获处理?原则是如何?
如果你需要通知到调用者,你代码出了问题,那么这时候就使用抛出处理.
如果代码是直接与用户打交道遇到了异常千万不要再抛,再抛的话,就给了用户了。
这时候就应该使用捕获处理。

*/
举例:throw 抛出
class Demo2{
    public static void main(String[] args)throws Exception{
        try{
            div(0,1,null);
        }catch(Exception e){
            System.out.print("1");
            throw new Exception();
        }

    }
public static void div(int i,int j,int[] arr) throws Exception{
        if(i==0){
            throw new Exception();
        }else if(arr==null){
            throw new NullPointerException();
        }
        int c=i/j;
        System.out.println(c);
    }
}

如果 main函数也抛出异常 那么到时候出错的时候直接打印printStackTrace

自定义异常类:
/*
sun提供了很多的异常类给我们用于描述程序中各种的不正常情况,但是sun 给我
提供异常类还不足以描述我们现实生活中所有不正常情况,那么这时候我们就需要
自定义异常类。

需求: 模拟feiQ上线的时候,如果没有插上网线,那么就抛出一个没有插上网线的异常,
如果已经插上了网上,那么就正常显示好友列表。

自定义异常类的步骤: 自定义一个类继承Exception即可。

class NullIpException extends Exception{
    public NullIpException(String x){
        super(x);
    }
}
class Demo2{
    public static void main(String[] args){
        String ip="sdf";
        ip=null;
        try{
            xx(ip);
        }catch(Exception z){
            z.printStackTrace();
        }

    }
    public static void xx(String ip)throws Exception{
        if(ip==null){
            throw new NullIpException("noip");
        }
        System.out.println("sdfsadfasdfas");
    }
}

—————| 运行时异常: 如果一个方法内部抛出了一个运行时异常,那么方法上 可以声明也可以不 声明,调用者可以以处理也可以不处理。
——————| 编译时异常(非运行时异常、受检异常): 如果一个方法内部抛出了一个编译时异常对象,那么方法上就必须要声明,而且调用者也必须要处理。

运行时异常: RuntimeException以及RuntimeException子类 都是属于运行时异常。

编译时异常: 除了运行时异常就是编译异常。

疑问: 为什么java编译器会如此严格要求编译时异常,对运行时异常如此宽松?

运行时异常都是可以通过程序员良好的编程习惯去避免,所以java编译器就没有严格要求处理运行时异常。

————————————————————————————————————
*/
finally块的 使用前提是必须要存在try块才能使用。

finally块的代码在任何情况下都会执行的,除了j
vm退出的情况。

finally非常适合做资源释放的工作,这样子可以保证资源文件在任何情况下都 会被释放。
finally:
结论:
1、不管有木有出现异常,finally块中代码都会执行;
2、当try和catch中有return时,finally仍然会执行;
3、finally是在return后面的表达式运算后执行的(此时并没有返回运算后的值,而是先把要返回的值保存起来,管finally中的代码怎么样,返回的值都不会改变,任然是之前保存的值),所以函数返回值是在finally执行前确定的;
4、finally中最好不要包含return,否则程序会提前退出,返回值不是try或catch中保存的返回值。

System.exit(0);//退出jvm 那么finally是不会执行的

举例:

class Demo2{
    public static void main(String[] args){
        try{
            div(1);
        }catch(Exception e){
            e.printStackTrace();
            System.out.println("xipanzi");
        }
    }
    public static void div(int n) throws Exception{
        try{
            System.exit(0);
        }catch(Exception e){
            System.out.print("sdf");
        }finally{
            System.out.print("finally");
        }
    }
}

如果try里面是return 那么也会执行finally 但是不会影响return的返回值
因为finally是在return之后才执行的


fianlly释放资源的代码

import java.io.*;
class Demo6 
{
    public static void main(String[] args) throws Exception
    {
        FileReader fileReader = null;
        try{
            //找到目标文件
            File file = new File("f:\\a.txt");
            //建立程序与文件的数据通道
            fileReader = new FileReader(file);
            //读取文件
            char[] buf = new char[1024];
            int length = 0; 
            length = fileReader.read(buf);
    System.out.println("读取到的内容:"+ new String(buf,0,length));
        }catch(IOException e){
            System.out.println("读取资源文件失败....");
        }finally{
            try{
                //关闭资源
                fileReader.close();
                System.out.println("释放资源文件成功....");
            }catch(IOException e){
                System.out.println("释放资源文件失败....");
            }
        }

    }
}

总结:
1:子类覆盖父类方法是,父类方法抛出异常,子类的覆盖方法可以不抛
出异常,或者抛出父类方法的异常,或者该父类方法异常的子类。
2:父类方法抛出了多个异常,子类覆盖方法时,只能抛出父类异常的子

3:父类没有抛出异常子类不可抛出异常
1:子类发生非运行时异常,需要进行try{}catch的(){}处理,不能
抛出。
4:子类不能比父类抛出更多的异常

版权声明:本文内容由阿里云实名注册用户自发贡献,版权归原作者所有,阿里云开发者社区不拥有其著作权,亦不承担相应法律责任。具体规则请查看《阿里云开发者社区用户服务协议》和《阿里云开发者社区知识产权保护指引》。如果您发现本社区中有涉嫌抄袭的内容,填写侵权投诉表单进行举报,一经查实,本社区将立刻删除涉嫌侵权内容。

分享:
开发与运维
使用钉钉扫一扫加入圈子
+ 订阅

集结各类场景实战经验,助你开发运维畅行无忧

其他文章